(** * Verification: stat*)

Require ModelProperties.

Require AuxiliaryLemmas.

Section statIsSecure.

(** -------------------------------------------*)

Lemma StatPSS:
 (s,t:SFSstate; u:SUBJECT)
  (SecureState s)->(TransFunc u s Stat t)->(SecureState t).
OpDontChangeStPSS.
Qed.


(** -------------------------------------------*)

Lemma StatPSP:
 (s,t:SFSstate; u:SUBJECT)
  (StarProperty s)->(TransFunc u s Stat t)->(StarProperty t).
OpDontChangeStPSP.
Qed.


(** -------------------------------------------*)

Lemma StatPCP:
    (s,t:SFSstate)(PreservesControlProp s Stat t).
Intros; Unfold PreservesControlProp; Intros Sub TF; Inversion TF;
  Unfold ControlProperty.
Split.
Intros.
Split.
Intro.
Absurd (DACCtrlAttrHaveChanged t t o0); Auto.

Intro; Absurd (MACObjCtrlAttrHaveChanged t t o0); Auto.

Intros; Absurd (MACSubCtrlAttrHaveChanged t t u0); Auto.

Qed.


End statIsSecure.

Hints Resolve StatPSS StatPSP StatPCP.

